#define _CRT_SECURE_NO_DEPRECATE
#include <iostream> 
#include <string>
#include <vector>
#include <sstream>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <math.h>
#include <stack>
#include <deque>
#include <numeric>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <bitset>
#define SEED 1337
#define MAXN 51
#define MAXM 51
const double MAXTIME = 1.88;
const double MIDTIME = 0.98;

using namespace std;

struct animal {
	vector <vector <bool> > form;
	int r, c, k, t;
	//t - dolna granica za bezopasnost
	//k - koeficient na porajenie sled padane
	animal(int r, int c, int k, int t) : r(r), c(c), k(k), t(t) {
		form.resize(r);
		for (int i = 0; i < r; ++i)
			form[i].resize(c);
	}
	bool operator < (const animal & oth) const {
		return k < oth.k;
	}
};

struct res_line{
	int anim, row, col;
	res_line(int a, int r, int c) : anim(a), row(r), col(c) {}
};

vector <pair <animal, int> > animals;
double start_time;
int field[MAXN][MAXM];
int buf_field[MAXN][MAXM];
int n, m, p;


double cur_time()
{
	return (double) clock() / (double) CLOCKS_PER_SEC - start_time;
}


void readinp()
{
	fill(&field[0][0], &field[MAXN - 1][MAXM], -1);
	fill(&buf_field[0][0], &buf_field[MAXN - 1][MAXM], -1);
	animals.clear();
	scanf("%d %d %d", &n, &m, &p);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) scanf("%d", &field[i][j]);
	int r, c, k, t;
	for (int i = 0; i < p; ++i)
	{
		scanf("%d %d %d %d\n", &r, &c, &k, &t);
		animals.push_back(make_pair(animal(r, c, k, t), i + 1));
		char ch;
		for (int z = 0; z < r; ++z)
		{
			for (int x = 0; x < c; ++x)
			{
				scanf("%c", &ch);
				animals[i].first.form[z][x] = ch == '1' ? 1 : 0;
			}
			scanf("\n");
		}
	}
}

void reset_field()
{
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			buf_field[i][j] = field[i][j];
}

int can(animal & a, pair <int, int> & pos)
{
	int res = 0;
	if (pos.first + a.r >= n || pos.second + a.c >= m) return false;
	for (int i = 0; i < a.r; ++i)
	{
		for (int j = 0; j < a.c; ++j)
		{
			if (a.form[i][j])
			{
				if (buf_field[i + pos.first][j + pos.second] < a.t)
					return false;
				else res += buf_field[i + pos.first][j + pos.second];
			}
		}
	}
	return res;
}

//returns safety to this jump
int drop(animal & a, pair <int, int> & pos)
{
	int saf = 0;
	for (int i = 0; i < a.r; ++i)
	{
		for (int j = 0; j < a.c; ++j)
		{
			if (a.form[i][j])
			{
				saf += buf_field[i + pos.first][j + pos.second];
				buf_field[i + pos.first][j + pos.second] /= a.k;
			}
		}
	}
	return saf;
}

int count_gens;
void solve()
{
	start_time = clock() / CLOCKS_PER_SEC;
	count_gens = 0;
	srand(SEED);
	vector <pair <int, int> > positions;
	vector <res_line> res;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			positions.push_back(make_pair(i, j));
	int best = -1;
	sort(animals.begin(), animals.end());
	while (cur_time() < MIDTIME)
	{
		count_gens++;
		vector <res_line> cur_conf;
		reset_field();
		int cur_res = 0;
		for (int i = 0; i < (int) animals.size(); ++i)
		{
			pair <int, int> wher(-1, -1);
			int curbest = -1;
			for (int j = 0; j < (int) positions.size(); ++j)
			{
				int zz = can(animals[i].first, positions[j]);
				if (zz)
				{
					if (curbest < zz)
					{
						curbest = zz;
						wher = positions[j];
					}
					//cur_res += drop(animals[i].first, positions[j]);
					//cur_conf.push_back(res_line(animals[i].second, positions[j].first, positions[j].second));
					//break;
				}
			}
			if (wher.first > -1 && wher.second > -1)
			{
				cur_res += drop(animals[i].first, wher);
				cur_conf.push_back(res_line(animals[i].second, wher.first, wher.second));
			}
		}
		if (best < cur_res)
		{
			best = cur_res;
			res = cur_conf;
		}
		next_permutation(animals.begin(), animals.end());
	}

	while (cur_time() < MAXTIME)
	{
		count_gens++;
		vector <res_line> cur_conf;
		reset_field();
		int cur_res = 0;
		for (int i = 0; i < (int) animals.size(); ++i)
		{
			pair <int, int> wher(-1, -1);
			int curbest = -1;
			for (int j = 0; j < (int) positions.size(); ++j)
			{
				int zz = can(animals[i].first, positions[j]);
				if (zz)
				{
					if (curbest < zz)
					{
						curbest = zz;
						wher = positions[j];
					}
					//cur_res += drop(animals[i].first, positions[j]);
					//cur_conf.push_back(res_line(animals[i].second, positions[j].first, positions[j].second));
					//break;
				}
			}
			if (wher.first > -1 && wher.second > -1)
			{
				cur_res += drop(animals[i].first, wher);
				cur_conf.push_back(res_line(animals[i].second, wher.first, wher.second));
			}
		}
		if (best < cur_res)
		{
			best = cur_res;
			res = cur_conf;
		}
		random_shuffle(animals.begin(), animals.end());
	}

	printf("%d\n", res.size());
	for (int i = 0; i < (int) res.size(); ++i)
	{
		printf("%d %d %d\n", res[i].anim, res[i].row + 1, res[i].col + 1);
	}
} 

int main()
{
	freopen("parash.in", "r", stdin);
	freopen("parash.out", "w", stdout);
	readinp();
	solve();
	//cerr << fixed << setprecision(6) << "TIME FOR PROGRAM : " << cur_time() << endl;
	//cerr << "Number of generated drops : " << count_gens << endl;
	return 0;
}